#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Fileversion=1.3.109.0
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Run_Tidy=y
#Tidy_Parameters=/pr=1 /uv=3 /tc=0 /sf /reel /refc /rerc /kv=100
#endregion

Opt('MustDeclareVars', 1)
#include <Array.au3>
Local $CLIparameters = $CMDLine, $IsRunning = False, $PID
;------------------------------------------------------ Debug & Testing -----------------------------------------------------------
If Not @Compiled Then
	;Some examples of how to use this:
	$CLIparameters[0] += 1
	ReDim $CLIparameters[$CLIparameters[0] + 1]
	$CLIparameters[$CLIparameters[0]] = 'BitTorrent Sync' ; specific test

	$CLIparameters[0] += 1
	ReDim $CLIparameters[$CLIparameters[0] + 1]
	$CLIparameters[$CLIparameters[0]] = 'BTSync.exe' ; specific test
EndIf

;------------------------------------------------------ Begin --------------------------------------------------------------------
If $CLIparameters[0] > 0 Then
	Local $AppPath = @ProgramFilesDir & '\' & $CLIparameters[1], $AppData = @AppDataDir & '\' & $CLIparameters[1], $AppExe = $CLIparameters[2]
	If FileExists($AppPath & '\' & $AppExe) Then ;First uninstall it
		$PID = ProcessExists($AppExe)
		While $PID
			ProcessClose($PID)
			Sleep(100)
			$PID = ProcessExists($AppExe)
		WEnd
		Run('"' & $AppPath & '\' & $AppExe & '" /UNINSTALL')
		ClickMe('Uninstall ' & $CLIparameters[1], '', 'Button2')
		Do
			Sleep(100)
		Until Not FileExists($AppPath & '\' & $AppExe)
	EndIf
	;Now install it
	If Not FileExists($AppData & '\settings.dat') Then DirCopy(@ScriptDir & '\' & $CLIparameters[1], $AppData, 1)
	Run(@ScriptDir & '\' & $AppExe)
	ClickMe($CLIparameters[1] & ' Setup', '', 'Button8')
	If Not ProcessExists($AppExe) Then Run($AppPath & '\' & $AppExe)
EndIf
Exit

Func ClickMe($a, $b, $c) ;"title", "text", controlID
	Do
		Sleep(10)
	Until ControlCommand($a, $b, $c, "IsVisible", "")
	Do
		Sleep(10)
	Until ControlCommand($a, $b, $c, "IsEnabled", "")
	While ControlCommand($a, $b, $c, "IsVisible", "")
		ControlClick($a, $b, $c)
		Sleep(10)
	WEnd
EndFunc
